/* Navigation sliders */

var activeElement;
var navBusy;

function closeNavElements(){
	var rel = activeElement.attr('rel');		
	$('#'+rel).slideUp('slow', function() {
		activeElement.removeClass('open');
		activeElement.parent().children('a.dropdown').removeClass('dropdown-open');
		activeElement = null;
		navBusy = false; 
	});
}

function openNavElement(obj){
	activeElement = obj;	
	rel = activeElement.attr('rel');
	$('#'+rel).slideDown('slow', function() {
		navBusy = false;		   
	});
	activeElement.addClass('open');
	activeElement.parent().children('a.dropdown').addClass('dropdown-open');
	activeElement = obj;
}

function activateNavElement(obj){	
	if(activeElement){
		var rel = activeElement.attr('rel');		
		$('#'+rel).slideUp('slow', function() {
			activeElement.removeClass('open');
			activeElement.parent().children('a.dropdown').removeClass('dropdown-open');
			openNavElement(obj);		   
		});
	}else{	
		openNavElement(obj);
	}	
}

$(document).ready(function() {
	$('nav .expand').click(function (event) {
		event.preventDefault();					
		if(!navBusy){
			navBusy = true;
			if($(this).hasClass('open')){
				closeNavElements();					
			}else{
				activateNavElement($(this));
			}
		}		
	});
});